# generated by datamodel-codegen:
#   filename:  entity/services/messagingService.json
#   timestamp: 2025-04-02T12:35:09+00:00

from __future__ import annotations

from enum import Enum
from typing import List, Optional, Union

from pydantic import ConfigDict, Field, RootModel
from typing_extensions import Annotated

from metadata.ingestion.models.custom_pydantic import BaseModel

from ...type import basic, entityHistory, entityReference, entityReferenceList, tagLabel
from .connections import testConnectionResult
from .connections.messaging import (
    customMessagingConnection,
    kafkaConnection,
    kinesisConnection,
    redpandaConnection,
)


class MessagingServiceType(Enum):
    Kafka = 'Kafka'
    Redpanda = 'Redpanda'
    Kinesis = 'Kinesis'
    CustomMessaging = 'CustomMessaging'


class Brokers(RootModel[List[str]]):
    root: Annotated[
        List[str],
        Field(
            description='Multiple bootstrap addresses for Kafka. Single proxy address for Pulsar.'
        ),
    ]


class MessagingConnection(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    config: Optional[
        Union[
            kafkaConnection.KafkaConnection,
            redpandaConnection.RedpandaConnection,
            kinesisConnection.KinesisConnection,
            customMessagingConnection.CustomMessagingConnection,
        ]
    ] = None


class MessagingService(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: Annotated[
        basic.Uuid,
        Field(description='Unique identifier of this messaging service instance.'),
    ]
    name: Annotated[
        basic.EntityName,
        Field(description='Name that identifies this messaging service.'),
    ]
    fullyQualifiedName: Annotated[
        Optional[basic.FullyQualifiedEntityName],
        Field(None, description='FullyQualifiedName same as `name`.'),
    ]
    serviceType: Annotated[
        MessagingServiceType,
        Field(description='Type of messaging service such as Kafka or Pulsar...'),
    ]
    description: Annotated[
        Optional[basic.Markdown],
        Field(None, description='Description of a messaging service instance.'),
    ]
    displayName: Annotated[
        Optional[str],
        Field(
            None,
            description='Display Name that identifies this messaging service. It could be title or label from the source services.',
        ),
    ]
    connection: Optional[MessagingConnection] = None
    pipelines: Annotated[
        Optional[entityReferenceList.EntityReferenceList],
        Field(
            None,
            description='References to pipelines deployed for this messaging service to extract topic configs and schemas.',
        ),
    ]
    testConnectionResult: Annotated[
        Optional[testConnectionResult.TestConnectionResult],
        Field(None, description='Last test connection results for this service'),
    ]
    tags: Annotated[
        Optional[List[tagLabel.TagLabel]],
        Field([], description='Tags for this Message Service.'),
    ]
    version: Annotated[
        Optional[entityHistory.EntityVersion],
        Field(None, description='Metadata version of the entity.'),
    ]
    updatedAt: Annotated[
        Optional[basic.Timestamp],
        Field(
            None,
            description='Last update time corresponding to the new version of the entity in Unix epoch time milliseconds.',
        ),
    ]
    updatedBy: Annotated[
        Optional[str], Field(None, description='User who made the update.')
    ]
    owners: Annotated[
        Optional[entityReferenceList.EntityReferenceList],
        Field(None, description='Owners of this messaging service.'),
    ]
    href: Annotated[
        Optional[basic.Href],
        Field(
            None,
            description='Link to the resource corresponding to this messaging service.',
        ),
    ]
    changeDescription: Annotated[
        Optional[entityHistory.ChangeDescription],
        Field(None, description='Change that lead to this version of the entity.'),
    ]
    incrementalChangeDescription: Annotated[
        Optional[entityHistory.ChangeDescription],
        Field(None, description='Change that lead to this version of the entity.'),
    ]
    deleted: Annotated[
        Optional[bool],
        Field(
            False, description='When `true` indicates the entity has been soft deleted.'
        ),
    ]
    dataProducts: Annotated[
        Optional[entityReferenceList.EntityReferenceList],
        Field(None, description='List of data products this entity is part of.'),
    ]
    domain: Annotated[
        Optional[entityReference.EntityReference],
        Field(None, description='Domain the Messaging service belongs to.'),
    ]
